/* StackByLinkedList.java
 *
 * 2009 yz
 */

import java.io.*;

public class StackByLinkedList {
    private static final int ERROR = -1;
    
    private static class Node {
	public int data;
	public Node next;
    }
    
    private static class Stack {
	private Node head;
	private int maxSize;
	
	public Stack(int sz) {
	    head = null;
	    maxSize = sz;
	}
	
	public int size() {
	    Node n = new Node();
	    int i;
	    
	    for(i = 0, n = head; n != null; n = n.next, i++);
	    
	    return i;
	}
	
	public Boolean empty() {
	    return (head == null);
	}
	
	public void push(int i) {
	    Node n = new Node();
	    
	    if(size() == maxSize) {
		System.out.println("Stack Overflow !");
		return;
	    }
	    
	    n.data = i;
	    n.next = head;
	    head = n;
	}
	
	public int pop() {
	    Node n = new Node();
	    int i;
	    
	    if(empty()) {
		System.out.println("Stack Underflow !");
		return ERROR;
	    }
	    
	    n = head;
	    i = n.data;
	    head = head.next;
	    n = null;
	    
	    return i;
	}
    }
    
    public static void main(String[] args) throws IOException {
	Stack stack = new Stack(10);
	BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	String str;
	int ret;
	
	System.out.println("Enter 'q' to quit");
	for(;;) {
	    System.out.print(": ");
	    str=br.readLine();
	    
	    if(str.equals("q"))
		break;
	    
	    if(str.equals(".")) {
		ret = stack.pop();
		if(ret != ERROR)
		    System.out.println("value on top is " + ret);
	    } else {
		stack.push(Integer.parseInt(str));
	    }
	}
    }
}
