/* StackByTable.java
 *
 * 2009 yz
 */

import java.io.*;

public class StackByTable {
    private static final int SIZE = 10;
    private static final int ERROR = -1;
    
    private static class Stack {
	private int[] stack;
	private int top;
	
	public Stack(int size) {
	    stack = new int[size];
	    top = 0;
	}
	
	public void push(int i) {
	    if(top == stack.length) {
		System.out.println("Stack Overflow !");
		return;
	    }
	    stack[top++] = i;
	}
	
	public int pop() {
	    if(top == 0) {
		System.out.println("Stack Underflow !");
		return ERROR;
	    }
	    return stack[--top];
	}
    }
    
    public static void main(String[] args) throws IOException {
	Stack stack = new Stack(SIZE);
	BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
	String str;
	int ret;
	
	System.out.println("Enter 'q' to quit");
	for(;;) {
	    System.out.print(": ");
	    str=br.readLine();
	    
	    if(str.equals("q"))
		break;
	    
	    if(str.equals(".")) {
		ret = stack.pop();
		if(ret != ERROR)
		    System.out.println("value on top is " + ret);
	    } else {
		stack.push(Integer.parseInt(str));
	    }
	}
    }
}
