/* stackByLinkedList.c
 *
 * 2009 yz
 */

#include <stdio.h>
#include <stdlib.h>

#define ERROR -1

typedef struct node {
  int data;
  struct node *next;
} Node;

typedef struct stack {
  Node *head;
  int size;
} Stack;

int size(Stack *s) {
  Node *n;
  int i;
  
  for(i = 0, n = s->head; n != NULL; n = n->next, i++);
  
  return i;
}

int empty(Stack *s) {
  return (s->head == NULL);
}

void push(Stack *s, int i) {
  Node *n;
  
  if(size(s) == s->size) {
    printf("Stack Overflow !\n");
    return;
  }
  
  n = (Node *)malloc(sizeof(Node));
  n->data = i;
  n->next = s->head;
  s->head = n;
}

int pop(Stack *s) {
  Node *n;
  int i;
  
  if(empty(s)) {
    printf("Stack Underflow !\n");
    return ERROR;
  }
  
  n = s->head;
  i = n->data;
  s->head = s->head->next;
  free(n);
  
  return i;
}

Stack *init(int sz) {
  Stack *s;
  
  s = (Stack *)malloc(sizeof(Stack));
  s->head = NULL;
  s->size = sz;
  
  return s;
}

void destroy(Stack *s) {
  while(!empty(s)) {
    pop(s);
  }
  free(s);
}

int main(void) {
  char s[8];
  int r;
  Stack *stack;
  
  stack = init(10);
  
  printf("Enter 'q' to quit\n");
  for(;;) {
    printf(": ");
    scanf("%s", s);
    
    if(*s == 'q')
      break;
    
    switch(*s) {
    case '.':
      r = pop(stack);
      if(r != ERROR)
	printf("value on top is %d\n", r);
      break;
    default:
      push(stack, atoi(s));
    }
  }
  
  destroy(stack);
  
  return 0;
}
